Project Chrono: chrono::fsi::ChSystemFsi_impl Class Reference

Public Member Functions | Public Attributes | Friends | List of all members
chrono::fsi::ChSystemFsi_impl Class Reference
FSI module » Physics objects

## Description

Data related function implementations for FSI system.

Inheritance diagram for chrono::fsi::ChSystemFsi_impl:
[legend]
Collaboration diagram for chrono::fsi::ChSystemFsi_impl:
[legend]

## Public Member Functions
| ChSystemFsi_impl (std::shared_ptr< SimParams > params)
void | AddSPHParticle (Real4 pos, Real4 rhoPresMu, Real3 vel=mR3(0.0), Real3 tauXxYyZz=mR3(0.0), Real3 tauXyXzYz=mR3(0.0))
| Add an SPH particle given its position, physical properties, velocity, and stress.
void | ResizeData (size_t numRigidBodies, size_t numFlexBodies1D, size_t numFlexBodies2D, size_t numFlexNodes)
| Resize the simulation data based on the FSI system constructed.
thrust::device_vector< Real4 > | GetParticleForces ()
| Extract forces applied on all SPH particles.
thrust::device_vector< Real4 > | GetParticleAccelerations ()
| Extract accelerations of all SPH particles.
thrust::device_vector< int > | FindParticlesInBox (const Real3 &hsize, const Real3 &pos, const Real3 &ax, const Real3 &ay, const Real3 &az)
| Find indices of all SPH particles inside the specified OBB.
thrust::device_vector< Real4 > | GetParticlePositions (const thrust::device_vector< int > &indices)
| Extract positions of all SPH particles with indices in the provided array.
thrust::device_vector< Real3 > | GetParticleVelocities (const thrust::device_vector< int > &indices)
| Extract velocities of all SPH particles with indices in the provided array.
thrust::device_vector< Real4 > | GetParticleForces (const thrust::device_vector< int > &indices)
| Extract forces applied to all SPH particles with indices in the provided array.
thrust::device_vector< Real4 > | GetParticleAccelerations (const thrust::device_vector< int > &indices)
| Extract accelerations of all SPH particles with indices in the provided array.
Public Member Functions inherited from chrono::fsi::ChFsiGeneral
| ChFsiGeneral (std::shared_ptr< SimParams > hostParams, std::shared_ptr< ChCounters > hostNumObjects)
| Constructor for the ChFsiGeneral class.
virtual | ~ChFsiGeneral ()
| Destructor of the ChFsiGeneral class.
void | computeGridSize (uint n, uint blockSize, uint &numBlocks, uint &numThreads)
| Compute number of blocks and threads for calculation on GPU.

## Public Attributes
std::shared_ptr< SimParams > | paramsH
| Parameters of the simulation.
std::shared_ptr< ChCounters > | numObjects
| Counters (SPH particles, BCE particles, bodies, etc).
std::shared_ptr< SphMarkerDataD > | sphMarkersD1
| Information of SPH particles at state 1 on device.
std::shared_ptr< SphMarkerDataD > | sphMarkersD2
| Information of SPH particles at state 2 on device.
std::shared_ptr< SphMarkerDataD > | sortedSphMarkersD
| Sorted information of SPH particles at state 1 on device.
std::shared_ptr< SphMarkerDataH > | sphMarkersH
| Information of SPH particles on host.
std::shared_ptr< FsiBodiesDataD > | fsiBodiesD1
| Information of rigid bodies at state 1 on device.
std::shared_ptr< FsiBodiesDataD > | fsiBodiesD2
| Information of rigid bodies at state 2 on device.
std::shared_ptr< FsiBodiesDataH > | fsiBodiesH
| Information of rigid bodies at state 1 on host.
std::shared_ptr< FsiMeshDataD > | fsiMeshD
| Information of mesh on device.
std::shared_ptr< FsiMeshDataH > | fsiMeshH
| Information of mesh on host.
std::shared_ptr< FsiGeneralData > | fsiGeneralData
| General FSI data needed in the simulation.
std::shared_ptr< ProximityDataD > | markersProximityD
| Information of neighbor search on the device.

## Friends
class | ChSystemFsi
| Base class of FSI system.

## Additional Inherited Members
Protected Member Functions inherited from chrono::fsi::ChFsiGeneral
uint | iDivUp (uint a, uint b)
| Return a/b or a/b + 1.

## Member Function Documentation

## ◆ GetParticleAccelerations()

thrust::device_vector< Real4 > chrono::fsi::ChSystemFsi_impl::GetParticleAccelerations | ( | const thrust::device_vector< int > & | indices | ) |

Extract accelerations of all SPH particles with indices in the provided array.

The return value is a device thrust vector.

## ◆ GetParticleForces()

thrust::device_vector< Real4 > chrono::fsi::ChSystemFsi_impl::GetParticleForces | ( | const thrust::device_vector< int > & | indices | ) |

Extract forces applied to all SPH particles with indices in the provided array.

The return value is a device thrust vector.

## ◆ GetParticlePositions()

thrust::device_vector< Real4 > chrono::fsi::ChSystemFsi_impl::GetParticlePositions | ( | const thrust::device_vector< int > & | indices | ) |

Extract positions of all SPH particles with indices in the provided array.

The return value is a device thrust vector.

## ◆ GetParticleVelocities()

thrust::device_vector< Real3 > chrono::fsi::ChSystemFsi_impl::GetParticleVelocities | ( | const thrust::device_vector< int > & | indices | ) |

Extract velocities of all SPH particles with indices in the provided array.

The return value is a device thrust vector.

The documentation for this class was generated from the following file:

- D:/W/B/src/chrono-9.0.1/src/chrono_fsi/physics/ChSystemFsi_impl.cuh